// AP Computer Science Marine Biology Case Study program
// Copyright (C) 2000  College Board and Educational Testing Service

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// randgen.cpp - comments fixed, copyright statement added 5/31/2000
// randgen.cpp - completely revised to avoid use of built-in rand()
//    Instead using technique/code described at 
//    http://courses.cs.vt.edu/~cs2604/spring02/Projects/1/RandomGenerator.html

/*---------------------------------------------------------
 * STUDENTS: Do not read beyond this point
 * --------------------------------------------------------*/

#include <ctime>                // for time()
#include <cstdlib>              // for rand/srand
#include "randgen.h"
using namespace std;

const unsigned long OURMAX = 2147483563L;
unsigned long serialize = 0;

// constructors

RandGen::RandGen() {
    // give each fish slightly different seed, even if at same time
    xPrev = ++serialize + (unsigned) time(NULL);   
    yPrev = (40692 * xPrev) % 2147483399L;
}

RandGen::RandGen(unsigned long seed)
{
    xPrev = seed;
    yPrev = (40692 * xPrev) % 2147483399L;
}

// public accessing functions

int RandGen::RandInt(int max)
// precondition: max > 0
// postcondition: returns int in [0..max)     
{  
  return int(RandReal() * max);
}

int RandGen::RandInt(int min, int max)
// precondition: min <= max     
// postcondition: returns int in [min..max]     
{ 
  return min + RandInt(max - min + 1);
}

double RandGen::RandReal()
// postcondition: returns double in [0..1)     
{     
  return Rand() / double(OURMAX); 
}

double RandGen::RandReal(double dmin, double dmax)
// precondition: dmin <= dmax     
// postcondition: returns double in [dmin..dmax)     
{
  double width = dmax - dmin;
  return RandReal() * width + dmin;
}

unsigned long RandGen::Rand() {
    xPrev = (40014 * xPrev) % OURMAX;
    yPrev = (40692 * yPrev) % 2147483399L;

    return (xPrev + yPrev) % OURMAX;
}
